"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = _default;
var DIRECTIVE = 'x-for';
var helperImportedFrom = 'babel-runtime-jsx-plus';
var helperImportedName = 'createList';
var helperLocalName = '__create_list__';

function _default(_ref) {
  var t = _ref.types;
  return {
    visitor: {
      Program: function Program(path) {
        path.__listHelperImported = false;
      },
      JSXElement: {
        exit: function exit(path) {
          var node = path.node,
              parentPath = path.parentPath;

          if (node.__jsxlist) {
            var _node$__jsxlist = node.__jsxlist,
                args = _node$__jsxlist.args,
                iterValue = _node$__jsxlist.iterValue;
            node.__jsxlist = null; // `__create_list__.call(this, value, render)`

            var replacer = t.callExpression(t.memberExpression(t.identifier(helperLocalName), t.identifier('call')), [t.thisExpression(), iterValue, t.arrowFunctionExpression(args, node)]);

            if (parentPath.isJSXElement()) {
              path.replaceWith(t.jsxExpressionContainer(replacer));
            } else {
              path.replaceWith(replacer);
            }
          }
        }
      },
      JSXAttribute: function JSXAttribute(path) {
        var node = path.node;

        if (t.isJSXIdentifier(node.name, {
          name: DIRECTIVE
        })) {
          // Check stynax.
          if (!t.isJSXExpressionContainer(node.value)) {
            // TODO: throw err prettier.
            console.warn('ignore x-for due to stynax error.');
            return;
          }

          var expression = node.value.expression;
          var params = [];
          var iterValue;

          if (t.isBinaryExpression(expression, {
            operator: 'in'
          })) {
            // x-for={(item, index) in value}
            var left = expression.left,
                right = expression.right;
            iterValue = right;

            if (t.isSequenceExpression(left)) {
              // x-for={(item, key) in value}
              params = left.expressions;
            } else if (t.isIdentifier(left)) {
              // x-for={item in value}
              params.push(left);
            } else {
              // x-for={??? in value}
              throw new Error('Stynax error of x-for.');
            }
          } else {
            // x-for={value}, x-for={callExp()}, ...
            iterValue = expression;
          }

          var rootPath = path.findParent(function (p) {
            return p.isProgram();
          });
          var parentJSXEl = path.findParent(function (p) {
            return p.isJSXElement();
          });
          parentJSXEl.node.__jsxlist = {
            args: params,
            iterValue: iterValue
          };

          if (rootPath.__listHelperImported === false) {
            var imported = t.identifier(helperImportedName);
            var local = t.identifier(helperLocalName);
            var importDeclaration = t.importDeclaration([t.importSpecifier(local, imported)], t.stringLiteral(helperImportedFrom));
            rootPath.unshiftContainer('body', importDeclaration);
            rootPath.__listHelperImported = true;
          }

          path.remove();
        }
      }
    }
  };
}